import numpy as np

DATOS = []

def CargaDatos( nombre ) :
	global DATOS
	DATOS = np.loadtxt( nombre )
	print( "Cargamos los datos" )
	print( DATOS.shape )

# Para buscar los pesos y los sesgos de la red
def Evalua( _n, vpar ) :
	entrada = np.zeros( (1,2) )
	C2 = np.array( [ [vpar[0], vpar[1] ], 
	                 [vpar[2], vpar[3] ] ] )
	vs2 = np.array( [[ vpar[4], vpar[5] ]] )	
	C3 = np.array( [ [ vpar[6] ],
	                 [ vpar[7] ]  ] )	
	vs3 = np.array( [[ vpar[8] ]] )

	n, m = DATOS.shape

	error = 0.0
	i = 0
	while i < n :
		entrada[0,0] = DATOS[i,0]
		entrada[0,1] = DATOS[i,1]

		S2 = entrada @ C2 + vs2
		S2 = 1.0/(1.0 + np.exp( -S2 ) )

		S3 = S2 @ C3 + vs3
		S3 = 1.0/(1.0 + np.exp( -S3 ) )

		e = DATOS[i,2] - S3[0,0]
		error += e*e

		i += 1

	return error

# La función de Rosenbrock
def Evalua2 ( _n, vpar ) :
	x = vpar[0]
	y = vpar[1]
	v = (1-x)*(1-x) + 100*(y-x*x)*(y-x*x)
	return v

# La función esférica:
def EvaluaEsferica( _n, vpar ) :
	i=0
	suma=0.0
	while i<_n :
		v = vpar[i]
		suma += v*v
		i += 1

	return( suma )

# Función Styblinski-Tank
#
# http://benchmarkfcns.xyz/benchmarkfcns/styblinskitankfcn.html
#
def Evalua1( _n, vpar ) :
	i=0
	suma=0.0
	while i<_n :
		v = vpar[i]
		v2 = v*v
		suma += v2*v2 - 16.0*v2 + 5.0*v
		i += 1

	return( 0.5*suma )

def EvaluaPrueba( _n, vpar ) :
	x = vpar[0]
	return (x-2)*(x-5) + np.sin(1.5*np.pi*x)
